package cn.com.infosec.crypto.digests;

import cn.com.infosec.crypto.ExtendedDigest;

public abstract class GeneralDigest implements ExtendedDigest {
   private static final int BYTE_LENGTH = 64;
   private byte[] xBuf;
   private int xBufOff;
   private long byteCount;

   protected GeneralDigest() {
      this.xBuf = new byte[4];
      this.xBufOff = 0;
   }

   protected GeneralDigest(GeneralDigest t) {
      GeneralDigest var10000 = this;
      GeneralDigest var10001 = t;
      GeneralDigest var10002 = this;
      GeneralDigest var10003 = t;
      super();
      byte[] var2;
      this.xBuf = var2 = new byte[t.xBuf.length];
      byte[] var10004 = t.xBuf;
      int t1 = var10004.length;
      System.arraycopy(var10004, 0, var2, 0, t1);
      var10002.xBufOff = var10003.xBufOff;
      var10000.byteCount = var10001.byteCount;
   }

   public void update(byte in) {
      byte[] var2 = this.xBuf;
      int var3;
      int var4;
      int var10000 = var4 = (var3 = this.xBufOff) + 1;
      this.xBufOff = var4;
      var2[var3] = in;
      if (var10000 == var2.length) {
         this.processWord(var2, 0);
         this.xBufOff = 0;
      }

      ++this.byteCount;
   }

   public void update(byte[] in, int inOff, int len) {
      while(this.xBufOff != 0 && len > 0) {
         this.update(in[inOff]);
         ++inOff;
         --len;
      }

      while(len > this.xBuf.length) {
         int var10002 = len;
         this.processWord(in, inOff);
         byte[] inOff1;
         len = inOff + (inOff1 = this.xBuf).length;
         int var4 = var10002 - inOff1.length;
         this.byteCount += (long)inOff1.length;
         inOff = len;
         len = var4;
      }

      while(len > 0) {
         this.update(in[inOff]);
         ++inOff;
         --len;
      }

   }

   public void finish() {
      long var1 = this.byteCount << 3;
      this.update((byte)-128);

      while(this.xBufOff != 0) {
         this.update((byte)0);
      }

      this.processLength(var1);
      this.processBlock();
   }

   public void reset() {
      this.byteCount = 0L;
      this.xBufOff = 0;

      byte[] var2;
      for(int var1 = 0; var1 < (var2 = this.xBuf).length; ++var1) {
         var2[var1] = 0;
      }

   }

   public int getByteLength() {
      return 64;
   }

   protected abstract void processWord(byte[] var1, int var2);

   protected abstract void processLength(long var1);

   protected abstract void processBlock();
}
